<template>
  <div class="hello">
    <button @click="handleLogOut()" class="x x-fixed-2">log-out</button>
    <h1>Toto App</h1>
    <p>Wpisuj, edytuj i usuwaj elementy ze swojej listy zadań</p>
    <input type="text" placeholder="wpisz zadanie" v-model="newItem" />
    <button @click="addItem">Dodaj</button>
    <ToDoItem
      v-for="item in items"
      v-bind:key="item.id"
      v-bind:item="item"
      @changeIsCompleted="changeIsCompleted"
      @deleteItem="deleteFromItems"
      @editTitle="changeTitle"
    />
    <button>Log-out</button>
  </div>
</template>

<script>
import Keycloak from "keycloak-js";
import ToDoItem from "../first-todo/ToDoItem.vue";
export default {
  mounted() {
    this.login();
  },

  components: {
    ToDoItem,
  },
  props: {
    msg: String,
  },
  data() {
    return {
      name: "HelloWorld",
      newItem: "",
      id: 10,
      items: [
        { title: "Witam", completed: true, id: 2 },
        { title: "Siemaneczko", completed: false, id: 1 },
      ],
    };
  },

  methods: {
    // printDupa(){
    //   console.log("dupa")
    // },
    addItem() {
      if (this.newItem.length >= 3) {
        this.items.push({ title: this.newItem, completed: false, id: this.id });
        this.id += 1;
        this.newItem = "";
      }
    },
    changeIsCompleted(id) {
      const index = this.items.findIndex((el) => el.id === id);
      this.items[index].completed = !this.items[index].completed;
    },
    deleteFromItems(id) {
      const index = this.items.findIndex((el) => el.id === id);
      this.items.splice(index, 1);
    },
    changeTitle(id, title) {
      if (title) {
        const index = this.items.findIndex((el) => el.id === id);
        this.items[index].title = title;
      }
    },
    // KEYCLOAK FN

    handleLogOut() {
      const MY_REALM = "test";
      const ENCODED_REDIRECT_URI = `${process.env.VUE_APP_BASE_APP_URL}`;
      window.location.replace(
        `${process.env.VUE_APP_BASE_KEYCLOAK_URL}realms/${MY_REALM}/protocol/openid-connect/logout?redirect_uri=${ENCODED_REDIRECT_URI}`
      );
    },
    login() {
      var keycloak = Keycloak({
        realm: `test`,
        url: `${process.env.VUE_APP_BASE_KEYCLOAK_URL}`,
        clientId: `fantastic-app`,
        "ssl-required": "all",
        resource: `fantastic-app`,
        "public-client": true,
        "confidential-port": 0,
      });
      keycloak
        .init({
          // flow: 'implicit',
          promiseType: "native",
          onLoad: "login-required",
        })
        .then((authenticated) => {
          this.$store.commit("TOKEN_SET", authenticated);
          console.log("TOKEN", authenticated);
          return authenticated;
        })
        .catch((error) => {
          console.error(error);
        });
      keycloak.onTokenExpired = () => {
        keycloak
          .updateToken(30)
          .then((refreshed) => {
            if (refreshed) {
              this.$store.commit("TOKEN_SET", keycloak.token);
            } else {
              console.log("Token is still valid");
            }
          })
          .catch((error) => {
            console.error(error);
          });
      };
    },
  },
};
</script>

<style scoped>
.item {
  border: 1px solid black;
  margin: 10px;
  padding: 10px;
}
.completed {
  text-decoration: line-through;
}
.completed h2 {
  opacity: 0.5;
}
.x {
  margin: 8px;
  padding: 8px;
  cursor: pointer;
  font-weight: bold;
  transition: 0.3s;
  background-color: #edd2ff;
  border: 1px solid #000;
  color: black;
}
.x:hover {
  color: white;
  background-color: #3a0061;
}
.x-fixed-2 {
  position: absolute;
  top: 10px;
  right: 10px;
}
</style>
